<template>
    <div class="report-box-plot-chart">

      <div class="y-axis-label">
        <span>{{ chartLabels.yAxisLabel }}</span>
      </div>

      <div class="report-canvas__wrapper">
        <div :class="`containerBody_${props.indicator}`" style="height: 100% !important">
          <canvas :id="`report-canvas_${props.indicator}`"></canvas>
        </div>
      </div>

    </div>

    <div class="x-axis-label">
      <span>
        {{ chartLabels.xAxisLabel }}
      </span>
    </div>
  </template>

  <script setup>
  import {
    computed,
    reactive,
    watchEffect,
    onMounted,
    toRaw,
  } from 'vue';

  import {
    Chart as ChartJS,
    registerables
  } from 'chart.js';

  import { BoxPlotController, BoxAndWiskers } from '@sgratzl/chartjs-chart-boxplot';

  import getChartLabels from 'src/composables/get_chart_labels';
  import getNormalizedName from 'src/composables/get_normalized_name';

  ChartJS.register(...registerables);
  ChartJS.register(BoxPlotController, BoxAndWiskers);

  const props = defineProps({
    data:       { type: Object, required: true },
    indicator:  { type: String, required: true },
  });

  const localData = computed({
    get: () => toRaw(props.data).reduce((acc, item) => {
      let key = Object.keys(item);
      let value = Object.values(item)[0];
      acc[`${key}`] = value;
      return acc
    }, {}),
  });

  const sort = (obj) => Object.keys(obj)
    .sort()
    .reduce((acc, c) => { acc[c] = obj[c]; return acc }, {});

  const makeChartConfig = () => {
    const data = sort(localData.value);
    return {
      type: 'boxplot',
      data: {
        labels: Object.keys(data).map(elem => {
          const year = elem.split(".")[0];
          const month = parseInt(elem.split(".")[1]) - 1;
          const monthName = getNormalizedName(month, 'month_short_name');
          return [monthName, year];
        }),
        datasets: [
          {
            data: Object.values(data),
            borderWidth: 1,
            borderColor: '#0066C0',
            itemRadius: 3,
            medianColor: '#0066C0',
            outlierRadius: 4,
            outlierBackgroundColor: 'lightblue',
          }
        ]
      },
      options: {
        scales: {
          y: {
            ticks: {
              callback: (value) => value.toLocaleString('es-EC', {style: 'currency', currency: 'USD'}),
            },
          },
        },
        animation: false,
        animations: {
            colors: false,
            x: false,
        },
        transitions: {
            active: {
            animation: {
                duration: 0,
            }
            }
        },
        resizeDelay: 0,

        responsive: true,
        maintainAspectRatio: false,
        elements: {
          boxandwhiskers: {
            backgroundColor: '#0066C0',
            lowerBackgroundColor: '#F26B30',
          }
        },
        plugins: {
          legend: { display: false}
        },
        layout: {
          padding: { left: 10, right: 20 }
        }
      }
    };
  };

  const chartLabels = getChartLabels(props.indicator);

  const canvas_id = `report-canvas_${props.indicator}`;

  let myChart = {};

  const createChart = function() {
    let length = data['data']['labels'].length;
    let canvasWidth = length * 15;

    const ctx = document.getElementById(canvas_id);
    ctx.style.width = `${canvasWidth}mm`;

    myChart = new ChartJS(ctx, data);
  };

  let data = reactive({});

  watchEffect(() => {
    data = makeChartConfig();
  });

  onMounted(() => {
    createChart();
  });

  </script>

  <style lang="scss" scoped>
  @use './report-box-plot-chart-component-stylesheet.scss';
  </style>